/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequest{}

// AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequest struct for AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequest
type AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequest struct {
	Config []AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner `json:"config,omitempty"`
}

// NewAppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequest instantiates a new AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequest() *AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequest {
	this := AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequest{}
	return &this
}

// NewAppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestWithDefaults instantiates a new AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestWithDefaults() *AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequest {
	this := AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequest{}
	return &this
}

// GetConfig returns the Config field value if set, zero value otherwise.
func (o *AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequest) GetConfig() []AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner {
	if o == nil || IsNil(o.Config) {
		var ret []AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner
		return ret
	}
	return o.Config
}

// GetConfigOk returns a tuple with the Config field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequest) GetConfigOk() ([]AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner, bool) {
	if o == nil || IsNil(o.Config) {
		return nil, false
	}
	return o.Config, true
}

// HasConfig returns a boolean if a field has been set.
func (o *AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequest) HasConfig() bool {
	if o != nil && !IsNil(o.Config) {
		return true
	}

	return false
}

// SetConfig gets a reference to the given []AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner and assigns it to the Config field.
func (o *AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequest) SetConfig(v []AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner) {
	o.Config = v
}

func (o AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Config) {
		toSerialize["config"] = o.Config
	}
	return toSerialize, nil
}

type NullableAppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequest struct {
	value *AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequest
	isSet bool
}

func (v NullableAppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequest) Get() *AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequest {
	return v.value
}

func (v *NullableAppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequest) Set(val *AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableAppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableAppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequest(val *AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequest) *NullableAppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequest {
	return &NullableAppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequest{value: val, isSet: true}
}

func (v NullableAppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
